import report
from report.report_sxw import *
from osv import osv,fields
import os

try:
    from DocumentConverter import DocumentConverter
    converter=DocumentConverter()
except Exception,e:
    print "ERROR: failed to create document converter:",e
    converter=None

class report_xml(osv.osv):
    _inherit="ir.actions.report.xml"
    _columns={
        "report_odt_path": fields.char("ODT path",size=128),
        "odt_convert": fields.selection([("pdf","PDF"),("doc","MS Word 97"),("rtf","Rich Text Format"),("html","HTML"),("txt","Text")],"Convert ODT"),
    }
report_xml()

def register_all(db):
    print "register_all"
    opj = os.path.join
    cr = db.cursor()
    cr.execute("SELECT * FROM ir_act_report_xml WHERE auto=%s ORDER BY id", (True,))
    result = cr.dictfetchall()
    cr.close()
    for r in result:
        if netsvc.service_exist('report.'+r['report_name']):
            continue
        if r['report_rml'] or r['report_rml_content_data'] or r['report_odt_path']:
            report_sxw('report.'+r['report_name'], r['model'],
                    opj('addons',r['report_rml'] or '/'), header=r['header'])
        if r['report_xsl']:
            report_rml('report.'+r['report_name'], r['model'],
                    opj('addons',r['report_xml']),
                    r['report_xsl'] and opj('addons',r['report_xsl']))
report.interface.register_all=register_all

def create_single_odt(self, cr, uid, ids, data, report_xml, context={}):
    print "create_single_odt"
    context = context.copy()
    report_type = report_xml.report_type
    context['parents'] = sxw_parents
    if report_xml.report_odt_path:
        sxw_in = file("addons/"+report_xml.report_odt_path,'r')
    else:
        sxw_in = StringIO.StringIO(report_xml.report_sxw_content)
    sxw_zin = zipfile.ZipFile(sxw_in, mode='r')
    rml = sxw_zin.read('content.xml')
    meta = sxw_zin.read('meta.xml')

    rml_parser = self.parser(cr, uid, self.name2, context)
    rml_parser.parents = sxw_parents
    rml_parser.tag = sxw_tag
    objs = self.getObjects(cr, uid, ids, context)
    rml_parser.set_context(objs, data, ids,report_xml.report_type)

    rml_dom_meta = node = etree.XML(meta)
    elements = node.findall(rml_parser.localcontext['name_space']["meta"]+"user-defined")
    for pe in elements:
        if pe.get(rml_parser.localcontext['name_space']["meta"]+"name"):
            if pe.get(rml_parser.localcontext['name_space']["meta"]+"name") == "Info 3":
                pe.getchildren()[0].text=data['id']
            if pe.get(rml_parser.localcontext['name_space']["meta"]+"name") == "Info 4":
                pe.getchildren()[0].text=data['model']
    meta = etree.tostring(rml_dom_meta)

    rml_dom =  etree.XML(rml)
    file("/tmp/odt1.xml","w").write(etree.tostring(rml_dom,pretty_print=True))
    rml_dom = self.preprocess_rml(rml_dom,report_type)
    file("/tmp/odt2.xml","w").write(etree.tostring(rml_dom,pretty_print=True))
    create_doc = self.generators[report_type]
    odt_dom=create_doc(rml_dom, rml_parser.localcontext)
    file("/tmp/odt3.xml","w").write(etree.tostring(odt_dom,pretty_print=True))
    odt = etree.tostring(odt_dom)

    sxw_out = StringIO.StringIO()
    sxw_zout = zipfile.ZipFile(sxw_out, mode='a')
    sxw_zout.writestr('content.xml', "<?xml version='1.0' encoding='UTF-8'?>" + \
            odt)
    sxw_zout.writestr('meta.xml', "<?xml version='1.0' encoding='UTF-8'?>" + \
            meta)

    #if report_xml.header:
    if 0:
        #Add corporate header/footer
        rml = tools.file_open(os.path.join('base', 'report', 'corporate_%s_header.xml' % report_type)).read()
        rml_parser = self.parser(cr, uid, self.name2, context)
        rml_parser.parents = sxw_parents
        rml_parser.tag = sxw_tag
        objs = self.getObjects(cr, uid, ids, context)
        rml_parser.set_context(objs, data, ids, report_xml.report_type)
        rml_dom = self.preprocess_rml(etree.XML(rml),report_type)
        create_doc = self.generators[report_type]
        odt = create_doc(rml_dom,rml_parser.localcontext)
        if report_xml.header:
            rml_parser._add_header(odt)
        odt = etree.tostring(odt)
        sxw_zout.writestr('styles.xml',"<?xml version='1.0' encoding='UTF-8'?>" + \
                odt)

    # copy all other files
    out_files=set(sxw_zout.namelist())
    for zf in sxw_zin.namelist():
        if zf in out_files:
            continue
        buf=sxw_zin.read(zf)
        sxw_zout.writestr(zf,buf)
    sxw_zin.close()
    sxw_in.close()

    sxw_zout.close()
    final_op = sxw_out.getvalue()
    sxw_out.close()

    if report_xml.odt_convert:
        final_op=convert_odt(final_op,report_xml.odt_convert)
        report_type=report_xml.odt_convert
    return (final_op, report_type)
report_sxw.create_single_odt=create_single_odt

def convert_odt(odt,ext):
    print "convert_odt",ext
    if not converter:
        print "error: ODT converter not available"
        return None
    f1=os.tmpnam()+".odt"
    f2=os.tmpnam()+"."+ext
    file(f1,"w").write(odt)
    converter.convert(f1,f2)
    res=file(f2).read()
    os.unlink(f1)
    os.unlink(f2)
    return res

odt_parents = ['{urn:oasis:names:tc:opendocument:xmlns:table:1.0}table-row','{urn:oasis:names:tc:opendocument:xmlns:office:1.0}body','{urn:oasis:names:tc:opendocument:xmlns:text:1.0}section']
report.preprocess.sxw_parents+=odt_parents
